/***********************************************************
 * Movable.c
 * аưȽؿ
 * Copyright(c) 1999,2000 Satofumi Tanaka
 *
 * $Id: Movable.c,v 1.1 2000/07/26 12:39:11 satofumi Exp $
 **********************************************************/
#define _MOVABLE_C_

#include "global.h"
#include "core.h"
#include "Movable.h"
#include <stdio.h>
#include <stdlib.h>


/* ޥ */
#define zahyo(x,y) (y)*BAN_YOKO+x	/*  ɸη׻ */
#define zahyo_x(z) (z)%BAN_YOKO		/* xɸη׻ */
#define zahyo_y(z) (z)/BAN_YOKO		/* yɸη׻ */

/*------------------------------------------------------------mglMove.c */
/* Movable(prev,next,fld,kom)
 * ̤ˤμˤưǽ
 * in:	prev		κɸ
 *		next		ưκɸ
 *		fld			۶
 *		kom			۶
 * out:	TRUE		ư
 *		FALSE		ưʤ
 */
boolean
Movable(int prev, int next, int *fld, KomaDef *kom)
{
	int px, py, nx, ny, xx, yy, flag, i;

	/* ȽʰŪȽ */
	if( fld[prev]==NONE ) return FALSE;	/* ʤ */
	if( prev==next ) return FALSE;		/* Ʊϥ */
	if( fld[next]!=NONE && fld_control(next)==fld_control(prev) )
		return FALSE;					/* ʬζ𤬤 */
	if( prev>=HAND ) {	/* Ǥ */
		if( fld[next]!=NONE ) return FALSE;	/* Ǥ˶𤬤ȥ */
		if( fld_type(prev)!= PAWN  &&
			fld_type(prev)!= LANCE &&
			fld_type(prev)!= KNIGHT ) return TRUE;	/* ⡢ᡢˡʳʤɤ */
	}

	/* κɸ */
		px = zahyo_x(prev);	/* ɸ */
		py = zahyo_y(prev);	/* ɸ */
	/* ưκɸ */
		nx = zahyo_x(next);	/* ɸ */
		ny = zahyo_y(next);	/* ɸ */

	if( fld_control(prev) == SENTE ) {
		xx = nx - px;	/* ץ졼䡼Σɸΰư() */
		yy = py - ny;	/* ץ졼䡼ɸΰư(夬) */
	} else {
		xx = px - nx;	/* ФΣɸΰư() */
		yy = ny - py;	/* ФΣɸΰư() */
	}

	/* ȽʶͭȽ */
	flag=FALSE;	/* ǥեȤFALSE */
	switch( fld_type(prev) ) {
		case KING:	/*  */
			if( (-1<=xx && xx<=1) && (-1<=yy && yy<=1) )	flag=TRUE;
			break;

		case GOLD:	/*  */
		case ReSILVER:	/*  */
		case ReKNIGHT:	/*  */
		case ReLANCE:	/*  */
		case RePAWN:	/*  */
			if( (-1<=xx && xx<=1) && (0<=yy && yy<=1) )	flag=TRUE;
			if( xx==0 && yy==-1 )	flag=TRUE;
			break;

		case ReBISHOP:	/* ζ(KING+BISHOP) */
			if( (-1<=xx && xx<=1) && (-1<=yy && yy<=1) )	flag=TRUE;

		case BISHOP:	/*  */
			if(xx==0) {	/* ΰư */
				if(-1<=yy && yy<=1) flag=TRUE;	/* orʤOK! */
				else {
					flag=TRUE;
					if(ny<py) {	/* ؤΰư */
						for(i=1;ny+i<py;i++)
							if( fld[zahyo(nx,ny+i)]!=NONE ) flag=FALSE;
					} else {	/* ؤΰư */
						for(i=1;py+i<ny;i++)
							if( fld[zahyo(nx,py+i)]!=NONE ) flag=FALSE;
					}
				}
			}
			if(yy==0) {	/* ΰư */
				if(-1<=xx && xx<=1) flag=TRUE;	/* orʤOK! */
				else {
					flag=TRUE;
					if(nx<px) {	/* ؤΰư */
						for(i=1;nx+i<px;i++)
							if( fld[zahyo(nx+i,ny)]!=NONE ) flag=FALSE;
					} else {	/* ؤΰư */
						for(i=1;px+i<nx;i++)
							if( fld[zahyo(px+i,ny)]!=NONE ) flag=FALSE;
					}
				}
			}
			break;

		case ReROOK:	/* (KING+ROOK) */
			if( (-1<=xx && xx<=1) && (-1<=yy && yy<=1) )	flag=TRUE;

		case ROOK:	/*  */
			if( nx<px && ny<py ) {	/* ؤΰư */
				if( nx+1==px && ny+1==py ) flag=TRUE;	/* ʤOK! */
				else {
					if(px-nx==py-ny) {
						flag=TRUE;
						for(i=1;nx+i<px;i++)
							if( fld[zahyo(nx+i,ny+i)] != NONE ) flag=FALSE;
					}
				}
			}
			if( px<nx && ny<py ) {	/* ؤΰư */
				if( nx-1==px && ny+1==py ) flag=TRUE;	/* ʤOK! */
				else {
					if(nx-px==py-ny) {
						flag=TRUE;
						for(i=1;nx-i>px;i++)
							if( fld[zahyo(nx-i,ny+i)] != NONE ) flag=FALSE;
					}
				}
			}
			if( nx<px && py<ny ) {	/* ؤΰư */
				if( nx+1==px && ny-1==py ) flag=TRUE;	/* ʤOK! */
				else {
					if(px-nx==ny-py) {
						flag=TRUE;
						for(i=1;nx+i<px;i++)
							if( fld[zahyo(nx+i,ny-i)] != NONE ) flag=FALSE;
					}
				}
			}
			if( px<nx && py<ny ) {	/* ؤΰư */
				if( nx-1==px && ny-1==py ) flag=TRUE;	/* ʤOK! */
				else {
					if(nx-px==ny-py) {
						flag=TRUE;
						for(i=1;nx-i>px;i++)
							if( fld[zahyo(nx-i,ny-i)] != NONE ) flag=FALSE;
					}
				}
			}
			break;

		case SILVER:	/*  */
			if( (-1<=xx && xx<=1) && yy==1 )	flag=TRUE;
			if( xx==-1 && yy==-1 )	flag=TRUE;
			if( xx==1 && yy==-1 )	flag=TRUE;
			break;

		case KNIGHT:	/*  */
			if( prev>=HAND ) {	/* ؤ */
				if( fld_control(prev)==SENTE && zahyo_y(next)<=1 ) break;
				if( fld_control(prev)==GOTE  && zahyo_y(next)>=7 ) break;
				flag=TRUE;
				break;
			}
			if( xx==-1 && yy==2 )	flag=TRUE;
			if( xx==1 && yy==2 )	flag=TRUE;
			break;

		case LANCE:	/*  */
			if( prev>=HAND ) {	/* ؤ */
				if( fld_control(prev)==SENTE && zahyo_y(next)==0 ) break;
				if( fld_control(prev)==GOTE  && zahyo_y(next)==8 ) break;
				flag=TRUE;
				break;
			}
			if(xx==0 && yy>0) {	/* ΰư */
				if(yy==1) flag=TRUE;	/* ʤOK! */
				else {
					flag=TRUE;
					if(fld_control(prev)==SENTE) {
						for(i=1;ny+i<py;i++)
							if( fld[zahyo(nx,ny+i)]!=NONE ) flag=FALSE;
					} else {
						for(i=1;ny-i>py;i++)
							if( fld[zahyo(nx,ny-i)]!=NONE ) flag=FALSE;
					}
				}
			}
			break;

		case PAWN:	/*  */
			if( prev<HAND ) {
				if( xx==0 && yy==1 )	flag=TRUE;
			} else {	/* ؤΥå */
				if( fld_control(prev)==SENTE && zahyo_y(next)==0 ) break;
				if( fld_control(prev)==GOTE  && zahyo_y(next)==8 ) break;
				flag=TRUE;
				for( i=0;i<BAN_TATE;i++ ) {
					if( fld_type( zahyo(nx,i) ) == PAWN &&
						fld_control( zahyo(nx,i) ) == fld_control(prev) )
					flag=FALSE;
				}
			}
			break;

		default:	break;
	}
	return flag;
}
