/***********************************************************
 * Sef.h
 * Ūɾإå(Static Evaluation Function)
 * Copyright(c) 1999,2000 Satofumi Tanaka
 *
 * $Id: Sef.h,v 1.1 2000/07/26 12:39:11 satofumi Exp $
 **********************************************************/
#ifndef _SEF_H_
#define _SEF_H_

#include <limits.h>


#ifdef _SEF_C_
	#define Sef_global
#else
	#define Sef_global extern
#endif


typedef struct {	/* ﷿ι¤ */
	char zahyo;		/* ζɸɸ */
	char value;		/* ɸɸɾ(ͥ) */
} KakoiDef;


/* Хѿ */
#define FACTOR			3	/* ɾǤο */
#define VIRFACTOR		3	/* ɾǤο */
#define FORMATION_MAX	10	/* ﷿κ */
#define SCORE_MAX	LONG_MAX	/* κ */
#define SCORE_MIN	LONG_MIN	/* κǾ */

Sef_global int gSef_RandMax[TEBAN_NUM];	/* ղäκ */
Sef_global int gSef_SefCoef[TEBAN_NUM][SITUATION_NUM][FACTOR];
Sef_global int gSef_TefCoef[TEBAN_NUM][SITUATION_NUM][VIRFACTOR];
Sef_global int gSef_PointKoma[TEBAN_NUM][KOMA_TYPE_MAX];	/* β */
Sef_global int gSef_Senkei[TEBAN_NUM]; /* ﷿ */
Sef_global int gSef_SenkeiMax[TEBAN_NUM];	/* ﷿ */
Sef_global KakoiDef gSef_Kakoi[TEBAN_NUM][FORMATION_MAX][KOMA_NUM];	/* Ȥ */


/* Хؿ */
long Sef(int *fld, KomaDef *kom);
long Tef(int *fld, KomaDef *kom, int prev, int next);


#endif
