/***********************************************************
 * mglConsl.c
 * Х󥽡ؿ
 * Copyright(c) 1999,2000 Satofumi Tanaka
 *
 * $Id: mglConsl.c,v 1.4 2000/08/08 14:27:50 satofumi Exp satofumi $
 **********************************************************/
#define _MGLCONSL_C_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../core/global.h"
#include "../core/Main.h"
#include "system.h"
#include "mglConsl.h"
#include "mglDisp.h"
#include "mglMain.h"
#include "mglArch.h"
#include "mglFile.h"

#ifdef SMG_MGL1
#include <mgl.h>	/* mgl1 */
#else
#include <mgl2.h>	/* mgl2 */
extern int mgl_vk_x,mgl_vk_y;
struct virtual_key *v_screen;	/*  */
struct virtual_key *v_quit;		/* quit */
struct virtual_key *v_matta;	/* Ԥä⡼ */
struct virtual_key *v_yes;		/* yes */
struct virtual_key *v_no;		/* no */
#endif


/* ѿؿ */
static struct textscreen *w3, *w4, *w5;
static struct textscreen *TextWaku(int x, int y, int w, int h, int border);
static void DispKifu(unsigned char *str);
static void SetMouse(int screen_width, int screen_height);
static FILE *TmpCopy(FILE *fp);

/*------------------------------------------------------------mglConsl.c */
/* SetMouse()
 * ݥƥ󥰥ǥХΥåȥå
 */
static void
SetMouse(int screen_width, int screen_height)
{
#ifndef SMG_MGL1
  int x,y,w,h;
  /*  */
  v_screen =
	mgl_create_virtual_key3(0,0,SCREEN_WIDTH,SCREEN_HEIGHT,
							SMG_MOUSE_DOWN, SMG_MOUSE_MOVE, SMG_MOUSE_UP);
  mgl_vk_attach( NULL, v_screen );
  /* quitܥ */
  x = screen_width-gFontSize.num;
  y = 0;
  w = gFontSize.num;
  h = gFontSize.num;
  GraphicWaku( x, y, w, h, gColor.ban );
  mgl_set_color( BLACK );
  mgl_set_font( gFontSize.num, FA_BOLD );
  mgl_draw_string( x, y, "", DIR_NORTH );
  v_quit = mgl_create_virtual_key( x, y, w, h, 'q' );
  mgl_vk_attach( v_screen, v_quit );
  /* Ԥäܥ */
  x = screen_width-gFontSize.num*2;
  y = 0;
  w = gFontSize.num;
  h = gFontSize.num;
  GraphicWaku( x, y, w, h, gColor.ban );
  mgl_set_color( BLACK );
  mgl_set_font( gFontSize.num, FA_NORMAL );
  mgl_draw_string( x, y, "", DIR_NORTH );
  v_matta = mgl_create_virtual_key( x, y, w, h, SMG_ESC );
  mgl_vk_attach( v_screen, v_matta );
#endif
}


/* SetConsoleLayout(screen_width,screen_height)
 * ̤礭˹碌ƥ쥤Ȥ
 */
void
SetConsoleLayout(int screen_width, int screen_height)
{
  int min_width = gBan.width + gFontSize.num*2 + gFontSize.stock_x*gStockYoko*2;
  if ( screen_width >= min_width ) {
	int space_width = gBan.x - gFontSize.num;
	int space_height;
  /* Width & Height */
	/*  */
	gWaku[1].width = gFontSize.stock_x * gStockYoko;
	gWaku[1].height = gFontSize.stock_y * gStockTate;
	/* 쥸å */
	gWaku[0].width = gWaku[1].width;
	gWaku[0].height = gFontSize.y * 3.5;
	/*  */
	gWaku[2].width = gWaku[1].width;
	gWaku[2].height = gWaku[1].height;
	/* ơ */
	gWaku[4].width = space_width - 2;
	gWaku[4].height = gFontSize.status;
	/*  */
	gWaku[3].width = gFontSize.kifu/2 * 16;
	space_height = screen_height-(gWaku[2].height+gWaku[4].height);
	gWaku[3].height = space_height - gFontSize.num*2 - gFontSize.kifu;
	/*  */
	gWaku[5].width = gFontSize.time/2 * 19;
	gWaku[5].height = gFontSize.time * 2 + 8;	/* +border */ 
	space_height = gWaku[0].height+gWaku[1].height+gWaku[5].height;
	if ( screen_height < space_height ) gWaku[5].height=-1;

  /* x & y */
	/* 쥸å */
	gWaku[0].x = (space_width-gWaku[0].width)/2 +gBan.x+gBan.width+gFontSize.num;
	gWaku[0].y = gFontSize.num;
	/*  */
	gWaku[1].x = (space_width-gWaku[1].width)/2 +gBan.x+gBan.width+gFontSize.num;
	gWaku[1].y = screen_height - gFontSize.num - gWaku[1].height;
	/*  */
	gWaku[2].x = ( space_width - gWaku[2].width )/2;
	gWaku[2].y = gFontSize.num;
	/* ơ */
	gWaku[4].x = 1;
	gWaku[4].y = screen_height - gFontSize.num - gWaku[4].height;
	/*  */
	gWaku[3].x = ( space_width - gWaku[3].width )/2;
	space_height=(gWaku[4].y - (gWaku[2].y+gWaku[2].height)) - gWaku[3].height;
	gWaku[3].y = space_height/2 + (gWaku[2].y+gWaku[2].height);
	/*  */
	gWaku[5].x = (space_width-gWaku[5].width)/2 +gBan.x+gBan.width+gFontSize.num;
	space_height=(gWaku[1].y - (gWaku[0].y+gWaku[0].height)) - gWaku[5].height;
	gWaku[5].y = space_height/2 + (gWaku[0].y+gWaku[0].height);
  } else {
	/* for PalmSize */
	int i;
	int space_height = gBan.y-gFontSize.num;
	for (i=0; i<WAKU_MAX; i++) {
	  gWaku[i].x = -1;
	  gWaku[i].y = -1;
	  gWaku[i].height = -1;
	  gWaku[i].width = -1;
	}
	if ( space_height > gFontSize.y ) {
	  /* 쥸å for Palm */
	  gWaku[0].width = gBan.width*0.6;
	  gWaku[0].height = space_height*0.9;
	  gWaku[0].x = (screen_width-gWaku[0].width)/2;
	  gWaku[0].y = space_height*0.05;
	  /* ơ for Palm  */
	  gWaku[4].width = gWaku[0].x -2;
	  gWaku[4].height = gFontSize.status*2;
	  gWaku[4].x = 1;
	  gWaku[4].y = gBan.y - gFontSize.num - gWaku[4].height;
	}
	/* 衦 for Palm  */
	if( space_height > gFontSize.y ){
	  int space_width;
	  gWaku[3].width = gFontSize.kifu/2 * 16;
	  gWaku[3].height = space_height*0.9;
	  gWaku[5].width = gFontSize.time/2 * 19;
	  gWaku[5].height = gFontSize.time * 2 + 8;	/* +border */ 
	  space_width = (screen_width-(gWaku[3].width+gWaku[5].width))/3;

	  gWaku[3].x = space_width;
	  gWaku[3].y = gBan.y + gBan.height + gFontSize.num + (space_height*0.05);
	  gWaku[5].x = gWaku[3].x + gWaku[3].width + space_width;
	  gWaku[5].y = gBan.y + gBan.height + gFontSize.num + (space_height*0.05);
	}
  }
}


/* WakuDraw()
 * Ȥ
 */
void
WakuDraw(int screen_width, int screen_height)
{
    int x,y,w,h;

	x=gWaku[0].x; y=gWaku[0].y; w=gWaku[0].width; h=gWaku[0].height;
    if( x<0 || y<0 || w<0 || h<0 ){
	  printf( "Copyright -ɽ- x:%d, y:%d, w:%d, h:%d\n", x,y,w,h );
	  gWakuFlag[0]=FALSE;
	} else {
	  DispCredit( x, y );
	  gWakuFlag[0]=TRUE;
	}
	x=gWaku[1].x; y=gWaku[1].y; w=gWaku[1].width; h=gWaku[1].height;
    if( x<0 || y<0 || w<0 || h<0 ){
	  printf( "()  -ɽ- x:%d, y:%d, w:%d, h:%d\n", x,y,w,h );
	  gWakuFlag[1]=FALSE;
	  gWakuFlag[2]=FALSE;	/* ƻϢ... */
	} else {
	  x=gWaku[2].x; y=gWaku[2].y; w=gWaku[2].width; h=gWaku[2].height;
	  if( x<0 || y<0 || w<0 || h<0 ){
		printf( "()  -ɽ- x:%d, y:%d, w:%d, h:%d\n", x,y,w,h );
		gWakuFlag[1]=FALSE;	/* ƻϢ... */
		gWakuFlag[2]=FALSE;
	  } else {
		gWakuFlag[1]=TRUE;
		gWakuFlag[2]=TRUE;
	  }
	}
	if ( !gWakuFlag[1] || !gWakuFlag[2] ) {	/* for ʰ׶ */
	  gStockYoko = 1;
	  gStockTate = PAWN;
	  gFontSize.stock_x = gFontSize.num;
	  gFontSize.stock_y = gFontSize.num;
	}
	x=gWaku[3].x; y=gWaku[3].y; w=gWaku[3].width; h=gWaku[3].height;
    if( x<0 || y<0 || w<0 || h<0 ){
	  printf( "      -ɽ- x:%d, y:%d, w:%d, h:%d\n", x,y,w,h );
	  gWakuFlag[3]=FALSE;
	} else {
	  w3 = TextWaku( x, y, w, h, 1 );
	  gWakuFlag[3]=TRUE;
	}
	x=gWaku[4].x; y=gWaku[4].y; w=gWaku[4].width; h=gWaku[4].height;
	x = -1;	/* ʬ,ɬ̵Τɽˤޤ */
    if( x<0 || y<0 || w<0 || h<0 ){
	  //printf( "ơ-ɽ- x:%d, y:%d, w:%d, h:%d\n", x,y,w,h );
	  gWakuFlag[4]=FALSE;
	} else {
	  w4 = TextWaku( x, y, w, h, 0 );
	  gWakuFlag[4]=TRUE;
	}
	x=gWaku[5].x; y=gWaku[5].y; w=gWaku[5].width; h=gWaku[5].height;
    if( x<0 || y<0 || w<0 || h<0 ){
	  printf( "      -ɽ- x:%d, y:%d, w:%d, h:%d\n", x,y,w,h );
	  gWakuFlag[5]=FALSE;
	} else {
	  w5 = TextWaku( x, y, w, h, 1 );
	  gWakuFlag[5]=TRUE;
	}
	SetMouse(screen_width,screen_height);	/* ݥƥ󥰥ǥХ */
}


/* GraphicWaku(x,y,w,h,c)
 * եåȤ
 */
void
GraphicWaku(int x, int y, int w, int h, int c)
{
	mgl_set_color( c );
	mgl_fill_rect( x, y, w, h );
	mgl_put_pixel( x, y, gColor.bg );
	mgl_put_pixel( x+w-1, y, gColor.bg );
	mgl_put_pixel( x, y+h-1, gColor.bg );
	mgl_put_pixel( x+w-1, y+h-1, gColor.bg );
}


/* TextWaku(x,y,w,h,border)
 * ƥȤ
 */
static struct textscreen *
TextWaku(int x, int y, int w, int h, int border)
{
	struct textscreen *ts;

	if( border==1 ) {
		ts = mgl_create_textscreen( NULL,x,y,w,h, TS_SAVE | TS_BORDER | TS_BLINE);
	} else {
		ts = mgl_create_textscreen( NULL, x, y, w, h, 0 );
	}
	mgl_ts_clear( ts );
	return ts;
}


/* WakuDrawEnd()
 * 
 */
void
WakuDrawEnd(void)
{
	if ( gWakuFlag[3] ) mgl_free_textscreen( w3 );
	if ( gWakuFlag[4] ) mgl_free_textscreen( w4 );
	if ( gWakuFlag[5] ) mgl_free_textscreen( w5 );
#ifndef SMG_MGL1
	mgl_vk_detach(v_matta,FALSE);
	mgl_vk_detach(v_quit,FALSE);
	mgl_vk_detach(v_screen,TRUE);
#endif
}


/* DisplayCredit(x,y)
 * 쥸åɽ
 */
void
DispCredit(int x, int y)
{
    char *title="";
	char *copyright="(C) Ȥ";
	char *large_copy="(C)1999,2000 Ȥ";
	char str[256];
	int str_x, str_y;

	GraphicWaku(x, y, gWaku[0].width, gWaku[0].height, GRAY2);
	GraphicWaku(x+1,y+1,gWaku[0].width-2,gWaku[0].height-2,WHITE);
	mgl_set_color( BLACK );
	/* ȥ */
	mgl_set_font( gFontSize.y, FA_NORMAL );
	str_x = (gWaku[0].width - strlen( title )*gFontSize.x)/2;
	str_y = (gFontSize.y+2)*0+5;
	if ( (str_y+gFontSize.y) < gWaku[0].height )
	  mgl_draw_string( x+str_x, y+str_y, title, DIR_NORTH );
	/* version */
	mgl_set_font( gFontSize.copy, FA_NORMAL );
	sprintf( str, "version %s", gVersion );
	str_x = (gWaku[0].width - strlen( str )*gFontSize.copy/2)/2;
	str_y = (gFontSize.y+2)*1+5;
	if ( (str_y+gFontSize.copy) < gWaku[0].height )
	  mgl_draw_string( x+str_x, y+str_y, str, DIR_NORTH );
	/* CopyRight */
	if ( strlen(large_copy)*gFontSize.copy/2 > gWaku[0].width ) {
	  str_x = (gWaku[0].width - strlen(copyright)*gFontSize.copy/2)/2;
	  str_y = (gFontSize.y+4)*2;
	  if ( (str_y+gFontSize.copy) < gWaku[0].height )
		mgl_draw_string( x+str_x, y+str_y, copyright, DIR_NORTH );
	} else {
	  str_x = (gWaku[0].width - strlen(large_copy)*gFontSize.copy/2)/2;
	  str_y = (gFontSize.y+4)*2;
	  if ( (str_y+gFontSize.copy) < gWaku[0].height )
		mgl_draw_string( x+str_x, y+str_y, large_copy, DIR_NORTH );
	}
	mgl_set_font( gFontSize.y, FA_NORMAL );	/* եȤ᤹ */
}


/* DispKifu(str)
 * ɽ
 */
static void
DispKifu(unsigned char *str)
{
    if ( !gWakuFlag[3] ) return;
	mgl_set_color( BLACK );
	mgl_set_font( gFontSize.kifu, FA_NORMAL );
	mgl_ts_put_string( w3, str, 0 );
	mgl_refresh();
}


/* ClearKifuWindow()
 * ξõ
 */
void
ClearKifuWindow(void)
{
    if ( !gWakuFlag[3] ) return;
	mgl_ts_clear( w3 );
}


/* DispMessage(str,button)
 * åɽȥԤ
 * button: YES/NO ܥ
 * out: key Ϥ줿
 */
int
DispMessage(unsigned char *str, int button)
{
	struct textscreen *wMessage;
	int key = SMG_NOINPUT;
	int len,width,height,x,y;

	/*  */
	len = strlen( str );
	width = len * gFontSize.x + 8;	/* width */
	height= gFontSize.y + 8;	/* height */
	if ( width > gBan.width ) width = gBan.width;
	if ( button==YES_NO_BUTTON ) height += gFontSize.y;
	x = gBan.x+gBan.width/2-width/2;	/* x */
	x += 4 - x%4;	/* 4ܿˤʤɽ...(^^; */
	y = gBan.y+gBan.height/2-height/2;	/* y */
	if ( x<0 || y<0 || width<0 || height<0 ) return FALSE;
	/*  */
	wMessage = TextWaku( x, y, width, height, 1 );
	mgl_set_color( BLACK );
	mgl_set_font( gFontSize.y, FA_NORMAL );
	mgl_ts_put_string( wMessage, str, 0 );
	if ( button==YES_NO_BUTTON )
	  mgl_ts_put_string( wMessage, "\n[Yes]/[No]", 0 );
#ifndef SMG_MGL1
	if ( button==YES_NO_BUTTON ) {
	  v_yes = mgl_create_virtual_key( x+gFontSize.x, y+gFontSize.y+4,
									  gFontSize.x*4, gFontSize.y, 'y' );
	  v_no = mgl_create_virtual_key( x+gFontSize.x*7, y+gFontSize.y+4,
									 gFontSize.x*3, gFontSize.y, 'n' );
	  mgl_vk_attach( v_screen, v_yes );
	  mgl_vk_attach( v_screen, v_no );
	  /* Ԥ */
	  while ( key ){
		key = mgl_get_key( SMG_NOWAIT );
		if ( key!=SMG_NOINPUT &&
			 key!=SMG_MOUSE_DOWN &&
			 key!=SMG_MOUSE_UP &&
			 key!=SMG_MOUSE_MOVE ) break;
	  }
	  mgl_vk_detach( v_yes, FALSE );
	  mgl_vk_detach( v_no , FALSE );
	  mgl_free_textscreen( wMessage );
	  //printf("DispMessage: %x\n",key);
	  return key;
	}	
#endif
	/* Ԥ */
	mgl_refresh();
	while ( key ){
	  key = mgl_get_key( SMG_NOWAIT );
	  if ( key!=SMG_NOINPUT &&
		   key!=SMG_MOUSE_UP &&
		   key!=SMG_MOUSE_MOVE ) break;
	}
	mgl_free_textscreen( wMessage );
	mgl_refresh();
	return key;
}


/* DispStatus(str)
 * ơɽ
 */
void
DispStatus(unsigned char *str)
{
    if ( !gWakuFlag[4] ) return;
	mgl_set_font( gFontSize.status, FA_NORMAL );
	mgl_set_color( BLACK );
	mgl_ts_clear( w4 );
	mgl_ts_goto( w4, 0, 0 );
	mgl_ts_put_string( w4, str, 0 );
	mgl_refresh();
}


/* TORYOMessage(control)
 * λΥå
 */
void
TORYOMessage(int control)
{
	char *toryo = "%TORYO";

	CsaPuts( toryo, gCsa_file );	/* ե˽񤭹 */
	if( control==SENTE ) {
		if( gGote_ban==RS232C ) ComSend( toryo );
		DispMessage( "m(__)m λ", NO_BUTTON );
	} else {
		if( gSente_ban==RS232C ) ComSend( toryo );
		DispMessage( "m(__)m λ", NO_BUTTON );
	}
	//mgl_get_key( SMG_WAIT );
}


/* DispMove(type, prev, next, control)
 * ưɽ
 * in:	type		μ0-13 ̾14-21 Ǥߡ
 *		prev			ưκɸ
 *		next			ưκɸ
 *		control		SENTE or GOTE
 */
void
DispMove(int type, int prev, int next, int control)
{
	unsigned char str[40];
	int nx, ny;
	unsigned char *num_char[2][BAN_YOKO] = {
	  {"","","","","","","","",""},
	  {"","","","","","ϻ","","Ȭ",""},
	};
	unsigned char *type_name[KOMA_TYPE_MAX+8] = {
		"","","","","","","","",
		"ζ","","","","","",
		"","","","","","","",""
	};

	/* ɸȶμ */
	nx = BAN_YOKO - zahyo_x(next) -1;	/* ɸ */
	ny = zahyo_y(next);				/* ɸ */
	if( prev >= HAND ) type += KOMA_TYPE_MAX;	/* Ǥξ */

	if ( control==SENTE )
		sprintf( str, "%3d %s%s%s\n",
			gTesuu, num_char[0][nx], num_char[1][ny], type_name[type]);
	else
		sprintf( str, "%3d %s%s%s\n",
			gTesuu, num_char[0][nx], num_char[1][ny], type_name[type]);

	DispKifu( str );	/* ɽ */
}


/* TimerDisplay(time_a,time_b,control)
 * ׹ͻ֤ɽ
 */
void
TimerDisplay(int time_a, int time_b, int control)
{
	char str[256];

    if ( !gWakuFlag[5] ) return;
	if( control==SENTE ) {	/* ξ */
		sprintf( str, "  %02d:%02d / %02d:%02d",
			time_a/60,
			time_a%60,
			time_b/60,
			time_b%60
		);
		mgl_ts_goto( w5, 0, 0 );
	} else {	/* ξ */
		sprintf( str, "  %02d:%02d / %02d:%02d",
			time_a/60,
			time_a%60,
			time_b/60,
			time_b%60
		);
		mgl_ts_goto( w5, 0, gFontSize.time );
	}
	mgl_set_color( BLACK );
	mgl_set_font( gFontSize.time, FA_NORMAL );
	mgl_ts_put_string( w5, str, 0 );	/* ɽ */
}


/* MattaMode()
 * Ԥä˥塼ɽ
 * out:	TRUE	жɤη³
 *		FALSE	Quit
 */
boolean
MattaMode(void)
{
	FILE *fp;		/* ե */
	FILE *fp_tmp;	/* tempե */
	int i, flag, ret, tesuu_max;
	int mgk = SMG_NOINPUT;
	int cur_y = 2;
	struct textscreen *wMenu;
	char *menu_str[] = {
	  "    ˥塼    \n",
	  "================\n",
	  "̤ʤ (f)\n",
	  "̤᤹   (b)\n",
	  "жɤ³ (c)\n",
	  "λ         (q)",
	  NULL
	};
	int len = strlen( menu_str[0] );
	int width = (len-1) * gFontSize.x;	/* width */
	int height= gFontSize.y*6;	/* height */
	int x = 4;
	int y = 4;
#ifndef SMG_MGL1
	struct virtual_key *v_menu[4];
	  v_menu[0]=mgl_create_virtual_key(x,y+gFontSize.y*2,width,gFontSize.y,'f');
	  v_menu[1]=mgl_create_virtual_key(x,y+gFontSize.y*3,width,gFontSize.y,'b');
	  v_menu[2]=mgl_create_virtual_key(x,y+gFontSize.y*4,width,gFontSize.y,'c');
	  v_menu[3]=mgl_create_virtual_key(x,y+gFontSize.y*5,width,gFontSize.y,'q');
	for (i=0; i<4; i++)
	  mgl_vk_attach( v_screen, v_menu[i] );
#endif
	if ( width > gBan.width ) return FALSE;
	tesuu_max = gTesuu;		/* κͤ */
	/* եΥԡ */
	fp = fopen( gCsa_file, OPENMODE_READ_TEXT );
	if( fp==NULL ) return FALSE;
	fp_tmp = TmpCopy( fp );
	fclose( fp );
	if( fp_tmp==NULL ) return FALSE;
	/* ˥塼ɽ */
	wMenu = TextWaku( x-4, y-4, width+8, height+8, 1 );
	mgl_set_color( BLACK );
	mgl_set_font( gFontSize.y, FA_NORMAL );
	for (i=0; i<6; i++ )
	  mgl_ts_put_string( wMenu, menu_str[i], 0 );
	mgl_set_color( REVERSE );
	mgl_fill_rect( x, y+gFontSize.y*cur_y, width, gFontSize.y );
	/* ɽԤ */
	flag = TRUE;
	ret = FALSE;
	while( flag ){
	  mgl_refresh();
	  if ( mgk==SMG_NOINPUT ) mgk = mgl_get_key( SMG_WAIT );
	  switch( mgk ) {

	  case SMG_UP:
		mgl_set_color( REVERSE );
		mgl_fill_rect( x, y+gFontSize.y*cur_y, width, gFontSize.y );
		if (cur_y>2) cur_y--;
		mgl_fill_rect( x, y+gFontSize.y*cur_y, width, gFontSize.y );
		mgk = SMG_NOINPUT;
		break;
	  case SMG_DOWN:
		mgl_set_color( REVERSE );
		mgl_fill_rect( x, y+gFontSize.y*cur_y, width, gFontSize.y );
		if (cur_y<5) cur_y++;
		mgl_fill_rect( x, y+gFontSize.y*cur_y, width, gFontSize.y );
		mgk = SMG_NOINPUT;
		break;

	  case SMG_SPACE:	/*  */
	  case SMG_RET:
		if (cur_y==2) mgk='f';
		else if (cur_y==3) mgk='b';
		else if (cur_y==4) mgk='c';
		else if (cur_y==5) mgk='q';
		else mgk=SMG_NOINPUT;
		break;

	  case 'f':	/* 2:̤ʤ */
		if( gTesuu<tesuu_max ) {
		  gTesuu++;
		  if( !CsaLoad(gTesuu,fp_tmp) ) {
			flag=FALSE;
			ret=FALSE;
		  } else {
			ReDraw( TRUE );
			mgl_ts_clear( wMenu );
			mgl_set_color( BLACK );
			mgl_set_font( gFontSize.y, FA_NORMAL );
			for (i=0; i<6; i++ )
			  mgl_ts_put_string( wMenu, menu_str[i], 0 );
			mgl_set_color( REVERSE );
			mgl_fill_rect( x, y+gFontSize.y*cur_y, width, gFontSize.y );
		  }
		}
		mgk = SMG_NOINPUT;
		break;
		
	  case 'b':	/* 3:̤᤹ */
		if( gTesuu>1 ) {
		  gTesuu--;
		  if( !CsaLoad(gTesuu,fp_tmp) ) {
			flag=FALSE;
			ret=FALSE;
		  } else {
			ReDraw( TRUE );
			mgl_ts_clear( wMenu );
			mgl_set_color( BLACK );
			mgl_set_font( gFontSize.y, FA_NORMAL );
			for (i=0; i<6; i++ )
			  mgl_ts_put_string( wMenu, menu_str[i], 0 );
			mgl_set_color( REVERSE );
			mgl_fill_rect( x, y+gFontSize.y*cur_y, width, gFontSize.y );
		  }
		}
		mgk = SMG_NOINPUT;
		break;
		
	  case 'c':	/* 4:continue */
	  case SMG_ESC:
		flag = FALSE;
		ret = TRUE;
		break;
		
	  case 'q':	/* 5:quit */
		flag = FALSE;
		ret = FALSE;
		break;
		
	  default:
		mgk = SMG_NOINPUT;
		break;
	  }
	}
#ifndef SMG_MGL1
	for (i=0; i<4; i++)
	  mgl_vk_detach( v_menu[i], FALSE );
#endif
	mgl_free_textscreen( wMenu );
	fclose( fp_tmp );
	ReDraw( TRUE );
	return ret;
}


/* TmpCopy(fp)
 * ե뤫ƥݥեΥԡ
 */
static FILE *
TmpCopy(FILE *fp)
{
	FILE *fp_tmp;
	char *tmpdir;
	int c;

	/* ĶѿΥå */
	tmpdir = getenv( "TMPDIR" );
	if( tmpdir==NULL ) putenv("TMPDIR=./");	/* Ķѿ */

	fp_tmp = tmpfile();	/* ƥݥե */
	if( fp_tmp==NULL ) return NULL;
	rewind( fp );
	while( (c=fgetc(fp)) != EOF ) {
		fputc( c, fp_tmp );
	}
	if( tmpdir==NULL ) putenv("TMPDIR=");	/* Ķѿβ */

	return fp_tmp;
}
