/***********************************************************
 * mglMove.c
 * аưؿ
 * Copyright(c) 1999,2000 Satofumi Tanaka
 *
 * $Id: mglMove.c,v 1.2 2000/08/01 15:45:44 satofumi Exp $
 **********************************************************/
#define _MGLMOVE_C_

#include <stdio.h>
#include <stdlib.h>
#include "../core/global.h"
#include "system.h"
#include "../core/Main.h"
#include "mglMove.h"
#include "mglMain.h"
#include "mglPlay.h"
#include "mglConsl.h"
#include "mglTime.h"

#ifdef SMG_MGL1
#include <mgl.h>	/* mgl1 */
#else
#include <mgl2.h>	/* mgl2 */
#endif


/*------------------------------------------------------------mglMove.c */
/* KomaMove(prev, next, control)
 * ΰư
 * in:	prev		κɸ
 *		next		ưκɸ
 *		control		SENTE or GOTE
 *		change		TRUE  ѿȤ
 *					FALSE ѿȤʤ
 * out:	TRUE		ư
 *		FALSE		λ
 */
boolean
KomaMove(int prev, int next, int control, int change)
{
  /* ưζ𤬤롪 */
  if( gField[next] != NONE ) {
	/* ̤Ȥä齪λ */
	if( gKoma[gField[next]].type==KING ) {
	  if( control==SENTE ) {
		DispMessage( "ξ", NO_BUTTON );
	  } else {
		DispMessage( "ξ", NO_BUTTON );
	  }
	  mgl_get_key( SMG_WAIT );
	  return FALSE;
	}
	if( gKoma[gField[next]].type>7 ) gKoma[gField[next]].type -= 6;	/* ѿȲ */
	if( control==SENTE ) {
	  gKoma[gField[next]].control = SENTE;	/* ۸ */
	  gField[SENTE_STOCK + STOCK_MAX -1] = gField[next];	/* ȥå */
	} else {
	  gKoma[gField[next]].control = GOTE;	/* ۸ */
	  gField[GOTE_STOCK + STOCK_MAX -1] = gField[next];	/* ȥå */
	}
  }
  
  /* Ũؤ */
  if( prev<HAND ) {	/* ǤǤϤʤ */
	if( 2<=gKoma[gField[prev]].type && gKoma[gField[prev]].type<=7 ) {
	  if( ( (prev>53 || next>53) && control==GOTE ) ||
		  ( (prev<27 || next<27) && control==SENTE ) ) {
		
		/* Фξѿȡ */
		if( (control==SENTE && gSente_ban==MOBA) ||
			(control==GOTE  &&  gGote_ban==MOBA) )
		  gKoma[gField[prev]].type += 6;		/* ѿȡ */
		
		/* ̿ξ change Τ */
		if( (control==SENTE && gSente_ban==RS232C) ||
			(control==GOTE  &&  gGote_ban==RS232C) )
		  if( change==TRUE )	/* TRUE ʤ */
			gKoma[gField[prev]].type += 6;	/* ѿȡ */
		
		/* ץ졼䡼ˤʹ */
		if( (control==SENTE && gSente_ban==PLAYER) ||
			(control==GOTE  &&  gGote_ban==PLAYER) ) {
		  int mgk = DispMessage( "ޤ", YES_NO_BUTTON );
		  switch ( mgk ) {
		  case 'n':
		  case 'N':
			break;
		  default:
			gKoma[gField[prev]].type += 6;	/* ѿȡ */
			break;
		  }
		  TimerUpdate( gTeban );
		}
	  }
	}
  }
  
  /* ư */
  gField[next] = gField[prev];	/* ư˥ԡ */
  gKoma[gField[next]].zahyo = next;	/* ɸ¸ */
  gField[prev] = NONE;		/* ξˤ϶Ϥʤ */
  StockSort( gField, gKoma, control );	/*  */
  
  DispMove( gKoma[gField[next]].type, prev, next, control );	/* ɽ */
  return TRUE;
}
