/***********************************************************
 * mglTime.c
 * лִؿ
 * Copyright(c) 1999,2000 Satofumi Tanaka
 *
 * $Id: mglTime.c,v 1.1 2000/07/26 12:39:11 satofumi Exp $
 **********************************************************/
#define _MGLTIME_C_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "../core/global.h"
#include "system.h"
#include "mglTime.h"
#include "mglConsl.h"

#ifdef SMG_MGL1
#include <mgl.h>	/* mgl1 */
#else
#include <mgl2.h>	/* mgl2 */
#endif


static clock_t time_start[TEBAN_NUM];
static clock_t time_prev;

/*------------------------------------------------------------mglTime.c */
/* TimerUpdate(control)
 * ׹ͻ֤ι
 * in:	control	ɤμ
 * out:	֡áˤ֤
 */
void
TimerUpdate(int control)
{
	clock_t time_now;

	mgl_refresh();
	time_now = clock();	/* ߤλ */
	gTimeThink = (time_now - time_start[control])/(int)CLOCKS_PER_SEC;
	/* ֤ѤäƤʤʤ꥿ */
	if( !((time_now-time_prev)/(int)CLOCKS_PER_SEC) ) return;
	/* ɽ */
	TimerDisplay( gTimeThink, gTimeTotal[control]+gTimeThink, control );
	/* prev ι */
	time_prev = time_now;
	/* ֤֤ */
	return;
}


/* TimerSet(control)
 * ¬Υå
 * in:	control	ɤμ
 */
void
TimerSet(int control)
{
	time_start[control] = clock();		/* Ȼ */
	time_prev = time_start[control];	/* prev ν */
	gTimeThink = 0;	/* ׹ͻ֤ν */
	/* ɽ */
	TimerDisplay( 0, gTimeTotal[control], control );
}


/* TimerStop(control)
 * ¬νλ
 * in:	control	
 */
void
TimerStop(int control)
{
	//TimerUpdate( control );
	gTimeThink++;
	gTimeTotal[control] += gTimeThink;
	TimerDisplay( 0, gTimeTotal[control], control );
}
