/***********************************************************
 * Main.c
 * Х르ꥺᥤ
 * Copyright(c) 1999,2000 Satofumi Tanaka
 *
 * $Id: Main.c,v 1.2 2000/08/01 15:45:44 satofumi Exp $
 **********************************************************/
#define _MAIN_C_

#include "global.h"
#include "core.h"
#include "Main.h"
#include "SubMain.h"
#include "Utility.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


/* core ΥХѿ */
int *fld;		/* ۥե(gFieldΥԡ) */
KomaDef *kom;	/* ۶(gKomaΥԡ) */

static boolean flag_fld;	/* TRUE:  malloc Ƥ */
static boolean flag_kom;	/* FALSE: free 줿 */

/* ؿ */
static void FreeNode(void);

/*------------------------------------------------------------algomain.c */
/* MobaThink()
 * Фλ׹
 * out:	TRUE:ư  FALSE:
 */
boolean
MobaThink(void)
{
	int flag = FALSE;
	TesujiDef Sasite;	/* Фλؤ */

	/* եɵڤӶʣ */
	flag_fld = FALSE;
	flag_kom = FALSE;
	fld = (int *)malloc( sizeof(int)*FIELD_MAX );
	kom = (KomaDef *)malloc( sizeof(KomaDef)*KOMA_NUM_PLUS );
	if( fld==NULL || kom==NULL ) {
		DispError( "out of memory" );
		return FALSE;
	}
	flag_fld = TRUE;
	flag_kom = TRUE;
	memcpy( fld, gField, sizeof(int)*FIELD_MAX );
	memcpy( kom, gKoma, sizeof(KomaDef)*KOMA_NUM_PLUS );

	/* ? or ? */
	if( gTeban == SENTE ) {
		gTeban_me  = SENTE;
		gStock_me  = SENTE_STOCK;
		gTeban_you = GOTE;
		gStock_you = GOTE_STOCK;
	} else {
		gTeban_me  = GOTE;
		gStock_me  = GOTE_STOCK;
		gTeban_you = SENTE;
		gStock_you = SENTE_STOCK;
	}
	/* Ĥ֤θʥԥ塼긢ѡ */
	//	if( gTimeTotal[gTeban_me] < 15*60 ) {
	//		gSasiteMax[gTeban_me] = gIni_SasiteMax[gTeban_me];	/* 15ʬ */
	//	} else {
	//		gSasiteMax[gTeban_me] = gIni_SasiteMax[gTeban_me] / 2;	/* 15ʬʾ */
	//	}
	gSasiteMax[gTeban_me] = gIni_SasiteMax[gTeban_me];
	gDepthMax[gTeban_me]  = gIni_DepthMax[gTeban_me];
	/* ﶷˤ륢르ꥺ*/
	while( !flag ) {
		switch( gSituation ) {
			case JOBAN:		/*  */
				if( JobanMain(&Sasite) ) flag=TRUE;
				continue;
			case CHUBAN:	/*  */
				if( ChubanMain(&Sasite) ) flag=TRUE;
				continue;
			case SHUBAN:	/*  */
				if( ShubanMain(&Sasite) ) flag=TRUE;
				continue;
			case TORYO:		/* λ */
				FreeNode();
				return FALSE;
		}
	}
	//DispStatus( "פǤ" );
	/* ɲ */
	AddLog( Sasite.prev, Sasite.next, gField[Sasite.prev] );
	/* ư */
	RegistMove( Sasite.prev, Sasite.next, FALSE );
	/* γ */
	FreeNode();

	return flag;
}


/* FreeNode() */
static void
FreeNode(void)
{
  if ( flag_fld ) {
	free( fld );
	fld = NULL;
	flag_fld = FALSE;
  }
  if ( flag_kom ) {
	free( kom );
	kom = NULL;
	flag_kom = FALSE;
  }
}


/* RegistMove(prev,next,change)
 * ưϿ
 */
void
RegistMove(int prev, int next, int change)
{
	gMove_prev = prev;
	gMove_next = next;
	gMove_change = change;
}
