/***********************************************************
 * SubMain.c
 * Х֥르ꥺ
 * Copyright(c) 1999,2000 Satofumi Tanaka
 *
 * $Id: SubMain.c,v 1.1 2000/07/26 12:39:11 satofumi Exp $
 **********************************************************/
#define _SUBMAIN_C_

#include "global.h"
#include "core.h"
#include "Main.h"
#include "SubMain.h"
#include "Search.h"
#include "Utility.h"
#include "Movable.h"
#include "Sef.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


/* ؿ */
static int SasiteMake(int *tsj_prev, int *tsj_next);
static boolean IsOute(TesujiDef *sasite);
static boolean IsLog(int prev, int next, int koma_no);
static boolean IsToryo(TesujiDef *sasite, long value);

/* к(Ʊ٤ؤʤ) */
#define LOG_MAX 8
static struct _log {
	int prev;
	int next;
	int koma_no;
} log[LOG_MAX];

extern int *fld;
extern KomaDef *kom;
/*------------------------------------------------------------algosub.c */
/* JobanMain(sasite)
 * ץᥤ
 */
boolean
JobanMain(TesujiDef *sasite)
{
	int nextnum, i;
	long value;
	int *tsj_prev;
	int *tsj_next;

	/* Υå */
	if( IsOute(sasite) ) return TRUE;
	/* פȽ */
	for( i=0;i<KOMA_NUM;i++ )
		if( kom[i].type>PAWN ) gSituation=CHUBAN;/* 𤬤 */
	if( fld[gStock_me]!=NONE || fld[gStock_you]!=NONE )
	  gSituation=CHUBAN;/* 𤬤 */
	if( gTesuu>30 ) gSituation=CHUBAN;/* 30ʾʤ */
	if( gSituation==CHUBAN ) return FALSE;

	/* פΤ褦ʤΤǼڤ */
	tsj_prev = (int *)TsjAlloc( gSasiteMax[gTeban_me] );	/* ڤγ */
	tsj_next = (int *)TsjAlloc( gSasiteMax[gTeban_me] );	/* ڤγ */
	nextnum = SasiteMake( tsj_prev, tsj_next );	/* ؤ */
	value = Calc( sasite, tsj_prev, tsj_next, nextnum );	/* ɾͤη׻ */
	TsjFree( tsj_prev, tsj_next );

	/* ڤϤ뤫 */
	if( nextnum<=3 ) {	/* ڤʤ */
		gSituation=CHUBAN;	/* פ */
		return FALSE;		/* ⤦ľ */
	}
	/* λ */
	if( IsToryo(sasite,value) ) return FALSE;

	return TRUE;	/* ؤ꤬ */
}


/* ChubanMain(sasite)
 * ץᥤ
 */
boolean
ChubanMain(TesujiDef *sasite)
{
	int nextnum;
	long value;
	int *tsj_prev;
	int *tsj_next;

	/* Υå */
	if( IsOute(sasite) ) return TRUE;
	/* פȽ */
	if( gTesuu>80 ) gSituation=SHUBAN;	/* 80ʾʤ */
	if( gSituation==SHUBAN ) return FALSE;
	/* ƶȯɽ */
	#if 0
	{
	  int i,ou;
	ou = king_me(gTeban_me);
	if( (kz(ou)%BAN_YOKO)<(BAN_YOKO/2) ) {	/* ̤¦λ */
		for( i=0;i<KOMA_NUM;i++ ) {
			if( kz(i)<HAND && kc(i)==gTeban_me )
				if( (kz(i)%BAN_YOKO)<(BAN_YOKO/2) )	/* ʤ */
					kr(i)=DEFENDER;	/* Ĥϼ */
				else
					kr(i)=ATTACKER;	/* ĤϹ */
		}
	} else {	/* ̤¦λ */
		for( i=0;i<KOMA_NUM;i++ ) {
			if( kz(i)<HAND && kc(i)==gTeban_me )
				if( (kz(i)%BAN_YOKO)<(BAN_YOKO/2) )	/* ʤ */
					kr(i)=ATTACKER;	/* ĤϹ */
				else
					kr(i)=DEFENDER;	/* Ĥϼ */
		}
	}
	}
	#endif
	/* õ */
	tsj_prev = (int *)TsjAlloc( gSasiteMax[gTeban_me] );	/* ڤγ */
	tsj_next = (int *)TsjAlloc( gSasiteMax[gTeban_me] );	/* ڤγ */
	nextnum = SasiteMake( tsj_prev, tsj_next );	/* ؤ */
	value = Calc( sasite, tsj_prev, tsj_next, nextnum );	/* ɾͤη׻ */
	TsjFree( tsj_prev, tsj_next );

	/* ڤϤ뤫 */
	if( nextnum==0 ) {
		gSituation=SHUBAN;	/* פͤ */
		return FALSE;
	}
	/* λ */
	if( IsToryo(sasite,value) ) return FALSE;

	return TRUE;	/* ؤ꤬ */
}


/* ShubanMain(sasite)
 * ץᥤ
 */
boolean
ShubanMain(TesujiDef *sasite)
{
	int nextnum;
	long value;
	int *tsj_prev;
	int *tsj_next;

	/* Υå */
	if( IsOute(sasite) ) return TRUE;
	/* õ */
	tsj_prev = (int *)TsjAlloc( gSasiteMax[gTeban_me] );	/* ڤγ */
	tsj_next = (int *)TsjAlloc( gSasiteMax[gTeban_me] );	/* ڤγ */
	nextnum = SasiteMake( tsj_prev, tsj_next );	/* ؤ */
	value = Calc( sasite, tsj_prev, tsj_next, nextnum );	/* ɾͤη׻ */
	TsjFree( tsj_prev, tsj_next );

	/* ڤϤ뤫 */
	if( nextnum==0 ) return FALSE;
	/* λ */
	if( IsToryo(sasite,value) ) return FALSE;

	return TRUE;	/* ؤ꤬ */
}


/* SasiteMake(tsj_prev,tsj_next)
 * ؤ
 * in:	tsj_prev, tsj_next	
 * out:	ڤο
 */
static int
SasiteMake(int *tsj_prev, int *tsj_next)
{
	int i,j,m;
	int num=0;
	int ret=0;
	TesujiDef vtsj[TESUJI_MAX];

	/* (No.1,No.21)(No.2,No.22)ΰư */
	for( j=0;j<21;j+=20 ) {
		for( i=1;i<3;i++ ) {
			if( kz(j+i)<HAND && kc(j+i)==gTeban_me ) {
				int s=0;
				int t=0;
				TesujiDef vvtsj[BAN_YOKO+BAN_TATE];/* ڤ */
				for( m=0;m<BAN_NUM;m++ ) {
					if( Movable(kz(j+i),m,fld,kom) ) {
						vvtsj[t].prev = kz(j+i);
						vvtsj[t].next = m;
						vvtsj[t].value= Tef(fld,kom,kz(j+i),m);
						t++;
					}
				}
				TesujiSort( vvtsj, t );
				/* (sasite/4) */
				if( t>=gSasiteMax[gTeban_me]/4 ){
				  s = gSasiteMax[gTeban_me]/4;
				} else {
				  s = t;
				}
				for( m=0; m<s && num<TESUJI_MAX ;m++ ){
					TsjCopy( &vtsj[num], &vvtsj[m] );
					num++;
				}
			}
		}
	}
	/* Ѱʳζμ */
	for( j=0;j<KOMA_NUM && num<TESUJI_MAX;j++ ) {	/*  */
		if( kz(j)<HAND && kc(j)==gTeban_me ) {
			if( kt(j)!=BISHOP && kt(j)!=ReBISHOP && kt(j)!=ROOK && kt(j)!=ReROOK ) {
				for( i=0; i<BAN_NUM && num<TESUJI_MAX; i++) { /*  */
					if( Movable( kz(j), i, fld, kom ) ) {
						vtsj[num].prev = kz(j);
						vtsj[num].next = i;
						vtsj[num].value= Tef(fld,kom,kz(j),i);
						num++;
					}
				}
			}
		}
	}
	/* Ǥμ */
	if( fld[gStock_me]!=NONE ) {
	    int type=NO_TYPE;	/* ƱФʤ褦 */
		TesujiDef vvtsj[ BAN_NUM ];/* ڤ */
		for( j=gStock_me; j<gStock_me+STOCK_MAX
						&& num<TESUJI_MAX; j++ ) {
			if( fld[j]!=NONE && fld_type(j)!=type ) {
				int s=0;
				int t=0;
				for( i=0; i<BAN_NUM; i++) {
					if( Movable(j,i,fld,kom) ) {
						vvtsj[t].prev = j;
						vvtsj[t].next = i;
						vvtsj[t].value= Tef(fld,kom,j,i);
						t++;
					}
				}
				TesujiSort( vvtsj, t );
				/* (sasite/4) */
				if( t>=gSasiteMax[gTeban_me]/4 ){
				  s = gSasiteMax[gTeban_me]/4;
				} else {
				  s = t;
				}
				for( m=0; m<s && num<TESUJI_MAX ;m++ ){
					TsjCopy( &vtsj[num], &vvtsj[m] );
					num++;
				}
				type = fld_type(j);
			}
		}
	}
	/* ƱڤϾõ */
	for( i=0; i<num-1; i++ ) {
		for( j=i+1; j<num; j++ ) {
			if(vtsj[i].prev==vtsj[j].prev
			   && vtsj[i].next==vtsj[j].next ){
				vtsj[j].prev = 0;
				vtsj[j].next = 0;
				vtsj[j].value= 0;
			}
		}
	}
	/* Ǥʤμڤõ */
	for( i=0; i<num; i++ ) {
		if( !TsjCheck(vtsj[i].prev, vtsj[i].next) ||
			IsLog(vtsj[i].prev, vtsj[i].next, fld[vtsj[i].prev]) ){
		    vtsj[i].prev = 0;
			vtsj[i].next = 0;
			vtsj[i].value= 0;
		}
	}

	TesujiSort( vtsj, num );	/* 夬äڤ򥽡Ȥ */

	/* ڤΥåȳ */
	ret = 0;
	for( i=0; i<num && ret<gSasiteMax[gTeban_me]; i++ ) {
		if( TsjCheck(vtsj[i].prev, vtsj[i].next) ) {
			tsj_prev[ret] = vtsj[i].prev;
			tsj_next[ret] = vtsj[i].next;
			ret++;
		}
	}

	return ret;
}


/* IsOute(sasite)
 * Υå
 * out:	TRUE	꤬o(^^)o
 *		FALSE	Ϥʤ
 */
static boolean
IsOute(TesujiDef *sasite)
{
	int i;
	int ou = king_you(gTeban_me);

	for( i=0;i<KOMA_NUM;i++ ) {
		if( kz(i)<HAND && kc(i)==gTeban_me ) {
			if( Movable( kz(i), kz(ou), fld, kom ) ){
				sasite->prev = kz(i);
				sasite->next = kz(ou);
				return TRUE;
			}
		}
	}
	return FALSE;
}


/* IsLog(prev, next, koma_no)
 * Υå
 * out:	TRUE	
 *		FALSE	ǤϤʤ
 */
static boolean
IsLog(int prev, int next, int koma_no)
{
	int i;
	for( i=0;i<LOG_MAX;i++ ) {
		if( log[i].prev==prev &&
			log[i].next==next &&
			log[i].koma_no== koma_no
		) return TRUE;
	}
	return FALSE;
}


/* AddLog(prev, next, koma_no)
 * ʴˤɲ
 */
void
AddLog(int prev, int next, int koma_no)
{
	memmove( log+1, log, (LOG_MAX-1)*sizeof(struct _log) );
	log[0].prev = prev;
	log[0].next = next;
	log[0].koma_no = koma_no;
}


/* IsToryo(value)
 * λΥå
 * out:	TRUE	λ
 *		FALSE	λƤϤʤ
 */
static boolean
IsToryo(TesujiDef *sasite, long value)
{
	int nextnum, old_depth;
	int *tsj_prev;
	int *tsj_next;

	if( value > SCORE_MIN ) return FALSE;
	//DispError( "õ\n" );
	/*  */
	old_depth = gDepthMax[gTeban_me];
	gDepthMax[gTeban_me] /= 2;	/* 1/2 õ */
	gSasiteMax[gTeban_me] *= 2;	/* 2 ܤθõ */
	if( gSasiteMax[gTeban_me]>TESUJI_MAX )
	  gSasiteMax[gTeban_me] = TESUJI_MAX;
	/* õ */
	tsj_prev = (int *)TsjAlloc( gSasiteMax[gTeban_me] );	/* ڤγ */
	tsj_next = (int *)TsjAlloc( gSasiteMax[gTeban_me] );	/* ڤγ */
	nextnum = SasiteMake( tsj_prev, tsj_next );	/* ؤ */
	value = Calc( sasite, tsj_prev, tsj_next, nextnum );	/* ɾͤη׻ */
	TsjFree( tsj_prev, tsj_next );
	/* λ */
	if( nextnum==0 || value==SCORE_MIN ) {
		gSituation=TORYO;
		//DispError( "λå\n" );
		return TRUE;	/* λå */
	}
	gDepthMax[gTeban_me] = old_depth;
	return FALSE;	/* ؤ꤬ */
}
