/***********************************************************
 * mglMain.c
 * Хᥤؿ
 * Copyright(c) 1999,2000 Satofumi Tanaka
 *
 * $Id: mglMain.c,v 1.3 2000/08/08 14:27:50 satofumi Exp satofumi $
 **********************************************************/
#define _MGLMAIN_C_

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include "../core/global.h"
#include "system.h"
#include "mglMain.h"
#include "mglGame.h"
#include "mglFile.h"
#include "mglDisp.h"
#include "mglArch.h"

#ifdef SMG_MGL1
#include <mgl.h>	/* mgl1 */
#else
#include <mgl2.h>	/* mgl2 */
#endif

#ifdef _MGL_WIN32
#define main	mgl_main
#endif
/*------------------------------------------------------------mglMain */
/* main()
 * ᥤ롼
 * shogimg [/S] [/G]
 */
int
main(int argc, char *argv[])
{
    sprintf( gVersion, "%s", VERSION );
	printf( "\n"
			"ShogiMG version %s\n"
			"Copyright(c) 1999,2000 Satofumi Tanaka\n"
			,gVersion
	);
	/* ѥ᡼å */
	gSente_ban = PLAYER;/* ( player ) */
	gGote_ban = MOBA;	/* ( computer ) */
	gOptText = FALSE;	/* ƥɽ( - ) */
	gOptColor = TRUE;	/* 顼ɽ( + ) */
	while( 1 ){
	  extern char *optarg;
	  int opt;
	  if( (opt=getopt(argc,argv,"S:s:G:g:TtMm")) == EOF ) break;
	  switch( opt ) {
		/*  */
		case 'S':
		case 's':
			if( atoi(optarg)==0 ) gSente_ban = PLAYER;
			if( atoi(optarg)==1 ) gSente_ban = MOBA;
			if( atoi(optarg)==9 ) gSente_ban = RS232C;
			break;
		/*  */
		case 'G':
		case 'g':
			if( atoi(optarg)==0 ) gGote_ban = PLAYER;
			if( atoi(optarg)==1 ) gGote_ban = MOBA;
			if( atoi(optarg)==9 ) gGote_ban = RS232C;
			break;
		/* Υƥɽ */
		case 'T':
		case 't':
		    gOptText = TRUE;
			break;
		/* Υɽ */
		case 'M':
		case 'm':
		    gOptColor = FALSE;
			break;
		/* إ */
		case '?':
			printf( "\n"
					"shogimg [-Sn] [-Gn] [-t] [-m] [-?] \n"
					"\n"
					"  -Sn:  жɼԤꤷޤ\n"
					"n = 0:ץ졼䡼(default)\n"
					"n = 1:\n"
					"n = 9:̿(DOS only)\n"
					"\n"
					"  -Gn:  жɼԤꤷޤ\n"
					"n = 0:ץ졼䡼\n"
					"n = 1:(default)\n"
					"n = 9:̿(DOS only)\n"
					"\n"
					"  -t:   ƥɽޤ\n"
					"  -m:   Υɽޤ\n"
					"  -?:   إפɽޤ\n"
			);
			exit(0);
		default:
			break;
	  }
	}
	/* ե */
	if( !SetFileName() ) exit(0);
	if( !IniLoad( SENTE ) ) exit(0);
	if( !IniLoad( GOTE ) ) exit(0);
	/* mgl  */
	if (!mgl_open_graph()) {
		printf("initialize error\n");
		exit(1);
	}
	mgl_set_color( WHITE );
	mgl_clear_screen();

	/* ೫! */
	Game();
	/*  */
	mgl_refresh();
	mgl_set_color( WHITE );
	mgl_clear_screen();
	mgl_close_graph();
	return(0);	/* ｪλ */
}
