/***********************************************************
 * mglPlay.c
 * Хץ졼䡼ؿ
 * Copyright(c) 1999,2000 Satofumi Tanaka
 *
 * $Id: mglPlay.c,v 1.3 2000/08/08 14:27:50 satofumi Exp satofumi $
 **********************************************************/
#define _MGLPLAY_C_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../core/global.h"
#include "../core/Main.h"
#include "../core/Movable.h"
#include "system.h"
#include "mglPlay.h"
#include "mglGame.h"
#include "mglDisp.h"
#include "mglConsl.h"
#include "mglTime.h"

#ifdef SMG_MGL1
#include <mgl.h>	/* mgl1 */
static int mgl_vk_x,mgl_vk_y;
#else
#include <mgl2.h>	/* mgl2 */
extern int mgl_vk_x,mgl_vk_y;
#endif


/* ѿؿ */
static int stock_cursor_x;
static int stock_cursor_y;
static int move_before_x;
static int move_before_y;
static struct screen *mem_s;	/* ɥåscreen */
static int prev;
static int mode;
/* mode 0: ư֥⡼
 * mode 1: ưꤹ⡼
 * mode 2: ζ֥⡼
 */
#define PREV_MODE	0
#define NEXT_MODE	1
#define STOCK_MODE	2

#define cur_zahyo(x,y) (y)*BAN_YOKO+x	/*  ɸη׻ */
#define cur_zahyo_x(z) (z)%BAN_YOKO		/* xɸη׻ */
#define cur_zahyo_y(z) (z)/BAN_YOKO		/* yɸη׻ */

static void MouseMove(void);
static int  MouseDown(void);
static void CursorToggle(int fx, int fy);
static void CursorMove(int xx, int yy);
static void FieldReverse(int fx, int fy);
static boolean IsStock(int x, int y);
static int StockPosition(int x, int y);
static void StockCursorToggle(int fx, int fy);

/*------------------------------------------------------------mglPlay.c */
/* PlayerThink()
 * ץ졼䡼λ׹
 * out 	TRUE:  ư
 * 		FALSE: 󥻥
 */
int
PlayerThink(void)
{
  int prev_x = 0;
  int prev_y = 0;
  int mgk = SMG_NOINPUT;
  boolean flag_mouse_move = FALSE;	/* TRUE: ɥå, FALSE:  */

  mode = PREV_MODE;
  /* ɥå screen  */
  mem_s = mgl_create_memscreen(gFontSize.koma, gFontSize.koma,
							   NULL, STK_NATIVE, 0);
  /* ޤư */
  CursorToggle( gCursor_x, gCursor_y );/*  */
  while(1){
	TimerUpdate( gTeban );
	if ( mgk==SMG_NOINPUT ) mgk = mgl_get_key( SMG_NOWAIT );
	switch(mgk) {

	case SMG_LEFT:	CursorMove(-1, 0);	mgk = SMG_NOINPUT;	break;
	case SMG_RIGHT:	CursorMove( 1, 0);	mgk = SMG_NOINPUT;	break;
	case SMG_UP:	CursorMove( 0,-1);	mgk = SMG_NOINPUT;	break;
	case SMG_DOWN:	CursorMove( 0, 1);	mgk = SMG_NOINPUT;	break;

	case 'q':
	  mgl_free_screen( mem_s );	/*  */
	  return PT_QUIT;	/* quit */

	case SMG_ESC:
	  if ( mode==PREV_MODE ) {	/* Ԥä⡼ */
		  CursorToggle( gCursor_x, gCursor_y );
		  mgl_free_screen( mem_s );	/*  */
		  return PT_MATTA;
	  }
	case SMG_NFER:
	case SMG_TAB:
	  /* Ǥ */
	  if( mode==PREV_MODE ) {
		if( gField[gPlayerStock]!=NONE ) {
		  if ( gTeban==SENTE ) {
			stock_cursor_x = 0;
			stock_cursor_y = 0;
		  } else {
			stock_cursor_x = gStockYoko-1;
			stock_cursor_y = gStockTate-1;
		  }
		  CursorToggle( gCursor_x, gCursor_y );
		  StockCursorToggle(stock_cursor_x, stock_cursor_y);
		  mode=STOCK_MODE;
		}
		mgk = SMG_NOINPUT;
		break;
	  }
	  /* 󥻥 */
	  if ( mode==NEXT_MODE ) {
		ReDraw( FALSE );
		CursorToggle( gCursor_x, gCursor_y );
		mode=PREV_MODE;
	  }
	  if ( mode==STOCK_MODE ) {
		StockCursorToggle(stock_cursor_x, stock_cursor_y);
		CursorToggle( gCursor_x, gCursor_y );
		mode=PREV_MODE;
	  }
	  mgk = SMG_NOINPUT;
	  break;

	case SMG_SPACE:	/*  */
	case SMG_RET:
	  if ( mode==NEXT_MODE ) {
		/* ưǽʤ쥸ȡ */
		if ( Movable(prev,cur_zahyo(gCursor_x,gCursor_y),gField,gKoma) ){
		  RegistMove( prev, cur_zahyo(gCursor_x,gCursor_y), FALSE );
		  mgl_free_screen( mem_s );	/*  */
		  return PT_GO;
		}
		/* ʳϥ󥻥 */
		mgk = SMG_TAB;
		break;
	  }
	  if ( mode==PREV_MODE ) {
		int sel = cur_zahyo( gCursor_x, gCursor_y );
		if( gField[sel]!=NONE && gKoma[gField[sel]].control==gTeban ) {
		  prev_x = gCursor_x;
		  prev_y = gCursor_y;
		  prev = cur_zahyo( prev_x, prev_y );
		  FieldReverse( prev_x, prev_y );	/* 򤷤ȿžɽ */
		  /* ¸ʤ(ɥå) */
		  mgl_bitblt( mem_s, 0, 0,
					  NULL, mgl_vk_x-gFontSize.koma/2, mgl_vk_y-gFontSize.koma/2,
					  gFontSize.koma, gFontSize.koma, 0 );
		  mode = NEXT_MODE;
		}
	  }		
	  if ( mode==STOCK_MODE ) {
		if ( IsStock(stock_cursor_x, stock_cursor_y) ) {
		  prev = StockPosition( stock_cursor_x, stock_cursor_y );
		  CursorToggle( gCursor_x, gCursor_y );
		  /* ¸ʤ(ɥå) */
		  mgl_bitblt( mem_s, 0, 0,
					  NULL, mgl_vk_x-gFontSize.koma/2, mgl_vk_y-gFontSize.koma/2,
					  gFontSize.koma, gFontSize.koma, 0 );
		  mode = NEXT_MODE;
		}
	  }
	  mgk = SMG_NOINPUT;
	  break;
	  
	case SMG_MOUSE_UP:	/* ޥUP( DOWN Ʊ) */
	  if ( !flag_mouse_move ) {	/* ɥåʤξ̵äȤˤ */
		mgk = SMG_NOINPUT;
		break;
	  }
	  if ( mode==NEXT_MODE ) {	/* 󥻥λΥ߽ */
		mgl_bitblt( NULL,
					move_before_x-gFontSize.koma/2,
					move_before_y-gFontSize.koma/2,
					mem_s, 0, 0,
					gFontSize.koma, gFontSize.koma, 0 );
	  }
	case SMG_MOUSE_DOWN:	/* ޥDOWN */
	  flag_mouse_move = FALSE;
	  mgk = MouseDown();
	  break;
	  
	case SMG_MOUSE_MOVE:	/* ޥMOVE */
	  MouseMove();
	  flag_mouse_move = TRUE;	/* ɥåON! */
	  mgk = SMG_NOINPUT;
	  break;
	  
	default:
	  mgk = SMG_NOINPUT;
	  break;
	}
  }
}


/* MouseMove()
 * ޥư
 */
static void
MouseMove(void)
{
  if ( mgl_vk_y < gFontSize.koma/2 ) return;
  if ( mode==PREV_MODE ) return;
  /*  */
  mgl_bitblt( NULL, move_before_x-gFontSize.koma/2, move_before_y-gFontSize.koma/2,
			  mem_s, 0, 0,
			  gFontSize.koma, gFontSize.koma, 0 );
  /* ¸ */
  mgl_bitblt( mem_s, 0, 0,
			  NULL, mgl_vk_x-gFontSize.koma/2, mgl_vk_y-gFontSize.koma/2,
			  gFontSize.koma, gFontSize.koma, 0 );
  /*  */
  MouseKomaDraw( mgl_vk_x-gFontSize.koma/2, mgl_vk_y-gFontSize.koma/2,
				   gKoma[gField[prev]].type, gTeban );
  move_before_x = mgl_vk_x;
  move_before_y = mgl_vk_y;
}


/* MouseDown()
 * ޥܥ󤬲줿
 */
static int
MouseDown(void)
{
  int mouse_x, mouse_y;
  int min_x, max_x, min_y, max_y, size;
  move_before_x = mgl_vk_x;
  move_before_y = mgl_vk_y;
  if ( (gBan.x < mgl_vk_x) && (mgl_vk_x < gBan.x+gBan.width) ) {
	if ( (gBan.y < mgl_vk_y) && (mgl_vk_y < gBan.y+gBan.height) ) {
	  if ( mode==STOCK_MODE ) {
		mode = NEXT_MODE;
		return SMG_TAB;
	  }		  
	  mouse_x = (mgl_vk_x - gBan.x) / gBan.size;
	  mouse_y = (mgl_vk_y - gBan.y) / gBan.size;
	  CursorMove(mouse_x-gCursor_x, mouse_y-gCursor_y);
	  return SMG_RET;
	}
  }
  /* 򥯥å */
  if( gWakuFlag[1] && gWakuFlag[2] ) {
	size = gFontSize.stock_y;
	if ( gTeban==SENTE ) {
	  min_x = gWaku[1].x;
	  min_y = gWaku[1].y;
	  max_x = gWaku[1].x + gWaku[1].width;
	  max_y = gWaku[1].y + gWaku[1].height;
	} else {
	  min_x = gWaku[2].x;
	  min_y = gWaku[2].y;
	  max_x = gWaku[2].x + gWaku[2].width;
	  max_y = gWaku[2].y + gWaku[2].height;
	}
  } else {	/* for ʰ׶ */
	size = gFontSize.stock_y*2;
	if ( gTeban==SENTE ) {
	  min_x = gBan.x + gBan.width + gFontSize.num;
	  min_y = gBan.y + gBan.height - size*PAWN;
	  max_x = min_x + gFontSize.stock_x;
	  max_y = gBan.y + gBan.height;
	} else {
	  min_x = gBan.x - gFontSize.num - gFontSize.stock_x;
	  min_y = gBan.y;
	  max_x = gBan.x - gFontSize.num;
	  max_y = gBan.y + size*PAWN;
	}
  }
  if ( (min_x < mgl_vk_x) && (mgl_vk_x < max_x) ) {
	if ( (min_y < mgl_vk_y) && (mgl_vk_y < max_y) ) {
	  if ( mode==PREV_MODE ) {
		mouse_x = (mgl_vk_x - min_x) / gFontSize.stock_x;
		mouse_y = (mgl_vk_y - min_y) / size;
		if ( IsStock( mouse_x, mouse_y ) ) {
		  stock_cursor_x = mouse_x;
		  stock_cursor_y = mouse_y;
		  StockCursorToggle(stock_cursor_x, stock_cursor_y);
		  mode = STOCK_MODE;
		  return SMG_RET;
		}
	  }
	}
  }
  /* 󥻥 */
  mode = NEXT_MODE;
  return SMG_TAB;
}


/* CursorToggle(fx,fy,doe)
 * orä
 * fx: 0-8 פΣɸ
 * fy: 0-8 פΣɸ
 */
static void
CursorToggle(int fx, int fy)
{
	int x = fx * gBan.size + gBan.x;
	int y = fy * gBan.size + gBan.y;
	mgl_set_color( REVERSE );
	mgl_draw_rect( x+1, y+1, gBan.size-1, gBan.size-1 );
	//	mgl_draw_rect( x+2, y+2, gBan.size-3, gBan.size-3 );
}


/* CursorMove(xx,yy)
 * ΰư
 *
 * xx ɸΰư
 * yy ɸΰư
 */
static void
CursorMove(int xx, int yy)
{
  int x,y;

  if ( mode==STOCK_MODE ) {	/*  */
	if( gWakuFlag[1] && gWakuFlag[2] ) {
	  x = stock_cursor_x + xx;	/* ưΣɸ */
	  y = stock_cursor_y + yy;	/* ưΣɸ */
	  if( (0<=x && x<gStockYoko) && (0<=y && y<gStockTate) && IsStock(x,y) ) {
		StockCursorToggle( x, y );
		StockCursorToggle(stock_cursor_x, stock_cursor_y );
		stock_cursor_x += xx;
		stock_cursor_y += yy;
	  }
	} else {	/* for ʰ׶ */
	  x = stock_cursor_x;		/* ɸѤʤ */
	  y = stock_cursor_y + yy;	/* ưΣɸ */
	  if( (0<=y && y<PAWN) ) {
		StockCursorToggle( x, y );
		StockCursorToggle(stock_cursor_x, stock_cursor_y );
		stock_cursor_y += yy;
	  }
	}
  } else {	/* ׾ */
	x = gCursor_x + xx;
	y = gCursor_y + yy;
	if( (0<=x && x<BAN_YOKO) && (0<=y && y<BAN_TATE) ) {
	  CursorToggle( x, y );
	  CursorToggle( gCursor_x, gCursor_y );
	  gCursor_x += xx;
	  gCursor_y += yy;
	}
  }
}


/* FieldReverse(fx,fy)
 * ˤȿžɽ
 * fx פΣɸ
 * fy פΣɸ
 */
static void
FieldReverse(int fx, int fy)
{
	int x = fx * gBan.size + gBan.x;
	int y = fy * gBan.size + gBan.y;
	mgl_set_color( REVERSE );
	mgl_fill_rect( x+1, y+1, gBan.size-1, gBan.size-1 );
}


/* IsStock(x,y)
 * x,y ˻𤬤뤫Ĵ٤
 * in:  x, y
 * TRUE: 𤬤, FALSE: 𤬤ʤ
 */
static boolean
IsStock(int x, int y)
{
	if( gWakuFlag[1] && gWakuFlag[2] ) {
	  if ( gField[StockPosition(x,y)] != NONE ) return TRUE;
	} else {	/* for ʰ׶ */
	  int i,type;
	  if ( gTeban==SENTE ) type = y + 1;
	  else type = PAWN - y;
	  for (i=0; i<STOCK_MAX; i++) {
		if( gKoma[gField[gPlayerStock+i]].type == type ) return TRUE;
	  }
	}
	return FALSE;
}


/* StockPosition(x,y)
 * gField Ǥΰ֤֤
 * in:  x, y
 * out: gField Ǥΰ
 */
static int
StockPosition(int x, int y)
{
	int pos = 0;

	if( gWakuFlag[1] && gWakuFlag[2] ) {
	  if( gTeban==SENTE ) {
		pos = gPlayerStock + y * gStockYoko + x;
	  } else {
		pos = gPlayerStock + (gStockTate-y-1)*gStockYoko + (gStockYoko-x-1);
	  }
	} else {	/* for ʰ׶ */
	  int i,type;
	  if ( gTeban==SENTE ) type = y + 1;
	  else type = PAWN - y;
	  for (i=0; i<STOCK_MAX; i++) {
		if( gKoma[gField[gPlayerStock+i]].type == type ) pos=gPlayerStock+i;
	  }
	}
	return pos;
}


/* StockCursorToggle(fx,fy)
 * ȥå
 * fx 0-? ɸ
 * fy 0-? ɸ
 */
static void
StockCursorToggle(int fx, int fy )
{
	int x,y,size;

	if( gWakuFlag[1] && gWakuFlag[2] ) {
	  size = gFontSize.stock_y;
	  if( gTeban==SENTE ) {
		x = fx * gFontSize.stock_x + gWaku[1].x;
		y = fy * gFontSize.stock_y + gWaku[1].y;
	  } else {
		x = fx * gFontSize.stock_x + gWaku[2].x;
		y = fy * gFontSize.stock_y + gWaku[2].y;
	  }
	} else {	/* for ʰ׶ */
	  size = gFontSize.stock_y*2;
	  if( gTeban==SENTE ) {
		x = gBan.x + gBan.width + gFontSize.num;
		y = gBan.y + gBan.height - (size * (PAWN-fy));
	  } else {
		x = gBan.x - gFontSize.num - gFontSize.stock_y;
		y = gBan.y + (size * fy);
	  }
	}
	mgl_set_color( REVERSE );
	mgl_fill_rect( x, y, gFontSize.stock_x, size );
}


/* StockSort()
 * ȥåΥ()
 */
void
StockSort(int *fld, KomaDef *kom, int teb)
{
	int i,j,t,n;
	int b[STOCK_MAX];

	if( teb==SENTE ) {
		n = SENTE_STOCK;	/*  */
	} else {
		n = GOTE_STOCK;		/*  */
	}
	memcpy( b, fld+n, sizeof(int)*STOCK_MAX );	/* ȥåΥԡ */
	for( i=1;i<STOCK_MAX;i++ ) {
		j = i;
		while( j>=1 && kom[b[j-1]].type<kom[b[j]].type ) {
			t = b[j];
			b[j] = b[j-1];
			b[j-1] =t;
			j--;
		}
	}
	memcpy( fld+n, b, sizeof(int)*STOCK_MAX );	/* Ƥӥԡ */
	/* ɸĴ */
	for( i=0;i<STOCK_MAX;i++ )
		if( b[i]!=NONE ) kom[b[i]].zahyo = n+i;	/* 𤬤ʤ񤭹 */
}
