/***********************************************************
 * system.h
 *  system إå
 * Copyright(c) 1999,2000 Satofumi Tanaka
 *
 * $Id: system.h,v 1.3 2000/08/08 14:27:50 satofumi Exp satofumi $
 **********************************************************/
#ifndef _SYSTEM_H_
#define _SYSTEM_H_


/* ޥ */
#define zahyo(x,y) (y)*BAN_YOKO+x	/*  ɸη׻ */
#define zahyo_x(z) (z)%BAN_YOKO		/* xɸη׻ */
#define zahyo_y(z) (z)/BAN_YOKO		/* yɸη׻ */


/* for mgl */
#define SMG_UP			MK_UP
#define SMG_DOWN		MK_DOWN
#define SMG_RIGHT		MK_RIGHT
#define SMG_LEFT		MK_LEFT
#ifdef MK_NFER
    #define SMG_NFER	MK_NFER
#else
    #define SMG_NFER	0xab00
#endif
#ifdef MK_ESC
    #define SMG_ESC		MK_ESC
#else
    #define SMG_ESC		0x001b
#endif
#ifdef MK_RET
    #define SMG_RET		MK_RET
#else
    #define SMG_RET		0x000d
#endif
#ifdef MK_TAB
    #define SMG_TAB		MK_TAB
#else
    #define SMG_TAB		0x0009
#endif
#ifdef MK_SPACE
    #define SMG_SPACE	MK_SPACE
#else
    #define SMG_SPACE	0x0020
#endif
#ifdef MK_NOINPUT
    #define SMG_NOINPUT	MK_NOINPUT
#else
    #define SMG_NOINPUT	-1
#endif
/* for Virtual key */
#ifdef MK_V1
    #define SMG_MOUSE_DOWN	MK_V1
#else
    #define SMG_MOUSE_DOWN	0x201
#endif
#ifdef MK_V2
    #define SMG_MOUSE_UP	MK_V2
#else
    #define SMG_MOUSE_UP	0x202
#endif
#ifdef MK_V3
    #define SMG_MOUSE_MOVE	MK_V3
#else
    #define SMG_MOUSE_MOVE	0x203
#endif

#define SMG_WAIT		-1
#define SMG_NOWAIT		0


/* for mgl_prefix */
#ifndef MGL_PREFIX
#define MGL_PREFIX
/*------------------------------------------------------------mglsetup */
#define mgl_open_graph()	open_graph()
#define mgl_close_graph()	close_graph()
#define mgl_refresh()	refresh()
#define mgl_create_memscreen(xs,ys,bitmap,kind,op) \
            create_memscreen(xs,ys,bitmap)
#define mgl_free_screen(s)	free_screen(s)
/*------------------------------------------------------------mglgraph */
#define mgl_set_color(col)	set_color(col)
#define mgl_draw_line(x1,y1,x2,y2)	draw_line(x1,y1,x2,y2)
#define mgl_clear_screen()	clear_screen()
#define mgl_draw_rect(x,y,xs,ys)	draw_rect(x,y,xs,ys)
#define mgl_fill_rect(x,y,xs,ys)	fill_rect(x,y,xs,ys)
#define mgl_put_pixel(x,y,col)	draw_pixel_wc(x,y,col)
#define mgl_bitblt(dst,dx,dy,src,sx,sy,xsize,ysize,op) \
            bitblt(dst,dx,dy,src,sx,sy,xsize,ysize,op)
/*------------------------------------------------------------mglfont */
#define mgl_set_font(size, attr)	set_font(size, attr)
#define mgl_draw_font(x,y,code,direction) \
			draw_font_rotated(x,y,code,direction)
#define mgl_draw_string(x,y,str,dir)	draw_string(x,y,str)
#define mgl_load_font(fname,w,h)	load_font(fname,w,h)
/*------------------------------------------------------------mglkey */
#define mgl_get_key(time_out)	get_key(time_out)
/*------------------------------------------------------------mgltext */
#define mgl_create_textscreen(s,x,y,xs,ys,attr) \
			create_textscreen(s,x,y,xs,ys,attr)
#define mgl_ts_clear(ts)	ts_clear(ts)
#define mgl_free_textscreen(t)	free_textscreen(t)
#define mgl_ts_put_string(t,str,op)	ts_put_string(t,str,op)
#define mgl_ts_goto(t,x,y)	ts_goto(t,x,y)

#endif

#endif
